--- old/usr/src/cmd/sgs/libld/common/args.c	2013-10-27 14:16:03.953339567 -0400
+++ new/usr/src/cmd/sgs/libld/common/args.c	2013-10-27 14:16:03.969573151 -0400
@@ -1679,8 +1679,19 @@
 
 		case '?':
 			DBG_CALL(Dbg_args_option(ofl->ofl_lml, ndx, c, NULL));
-			eprintf(ofl->ofl_lml, ERR_FATAL,
-			    MSG_INTL(MSG_ARG_UNKNOWN), optopt);
+			/*
+			 * If the option character is '-', we're looking at a
+			 * long option which couldn't be translated, display a
+			 * more useful error.
+			 */
+			if (optopt == '-') {
+				eprintf(ofl->ofl_lml, ERR_FATAL,
+				    MSG_INTL(MSG_ARG_LONG_UNKNOWN),
+				    argv[optind-1]);
+			} else {
+				eprintf(ofl->ofl_lml, ERR_FATAL,
+				    MSG_INTL(MSG_ARG_UNKNOWN), optopt);
+			}
 			(*usage)++;
 			break;
 
